# -*- coding: utf-8 -*-
#$Id: ATCTSSTestCase.py 91 2006-03-09 16:24:08Z taka $
#############################################################################
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

#
# ATCTSSTestCase test setup
#

from Products.PloneTestCase import PloneTestCase

PRODUCTS = ['Archetypes', 'ATContentTypes', 'ATCTSmallSample']

PloneTestCase.installProduct('ATCTSmallSample')
PloneTestCase.setupPloneSite(products=PRODUCTS)


class ATCTSSTestCase(PloneTestCase.PloneTestCase):

    defaultTitle = 'Default Testing Title'

    def afterSetUp(self):
        self._createSmallContent(self.folder)

    def _createSmallContent(self, folder, id='small', title=defaultTitle):
        """Creates and returns a refence to a SmallContent.
        This method publishes a SmallContent instance under folder.  It fills in
        all of the standard properties."""
        folder.invokeFactory('SmallContent',
                             id=id,
                             title=title,
                             description='A SmallContent instance for unit tests.',
                            )
        small = getattr(folder, id)
        self.portal.portal_workflow.doActionFor(small, 'submit')
        return small

    def uninstallProduct(self, product_name):
        # Removes a product
        tool = getattr(self.portal, 'portal_quickinstaller')
        if tool.isProductInstalled(product_name):
            tool.uninstallProducts([product_name])

